﻿/*************************
 * Purpose: Write out the pattern with '*'
 * 
 * Inputs:1. mlen, 2. min_sup, 3. segno, 4. dPattern
 * Output: Console.WriteLine the patterns
 * 
 * ***********************/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PartialPeriodic
{
    
    public class CreatePattern
    {
 
        public CreatePattern(int mlen, double min_sup, int segno, Dictionary<string, int> dPattern)
        {
            foreach (KeyValuePair<string, int> pair in dPattern)
            {
                string[] strItem = new string[mlen + 1];
                string pattern = "(,)";
                //string input = subpat[i].tItem;
                string input = pair.Key;
                Regex regex = new Regex(pattern);         // Split
                string[] substrings = regex.Split(input, input.Length);
                for (int k = 0; k < substrings.Length; k++)
                {
                    //string c1 = "";
                    if (substrings[k].Length > 3) //pattern 03XXA
                    {
                        int pos = Int32.Parse(substrings[k].Substring(0, 2));
                        int nc = Int32.Parse(substrings[k].Substring(2, 3));
                        if (strItem[pos] == null)
                            strItem[pos] = "'" + nc + "'";
                        else
                            strItem[pos] = strItem[pos] + "," + "'" + nc + "'";
                    }
                }
                string writestr = "";
                for (int j = 1; j <= mlen; j++)
                {
                    if (strItem[j] == null) { strItem[j] = "*"; }
                    writestr = writestr + strItem[j];
                }
                int pcnt = pair.Value;
                double outsup = (double)pcnt / segno * 100;
                outsup = Math.Round(outsup, 2);
                Console.WriteLine(writestr + ", Count= " + string.Format("{0:##0}", pcnt) + ", Support =" + outsup + "%");
            }

        }
    }
}
