﻿/********************************************************
 * Projection-based Partial Periodic Pattern Mining
 * 
 * Called from FormMain.cs	
 * Inputs: 1. min_sup 2. Segno 3.Dict Segment 4. Dict F1 
 * Author：Kung-Jiuan Yang   Last Update:2013/06/18 
********************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PartialPeriodic
{
    public class PRAMain
    {
        int segno = 0;
        double min_sup;
        int candcnt = 0;

        Dictionary<string, int> dSeg = new Dictionary<string, int>();
        Dictionary<string, double> dF1 = new Dictionary<string, double>();
        Dictionary<string, int> dPattern = new Dictionary<string, int>();

        public PRAMain(double min_sup, int segno, Dictionary<string, int> dSeg, Dictionary<string, double> dF1)
        {
            try
            {
                //===========================
                // Set Parameters
                //===========================
                // 
                this.min_sup = min_sup;
                this.segno = segno;
                this.dSeg = dSeg;
                this.dF1 = dF1;
                string[] opPostfix = new string[segno];

                foreach (KeyValuePair<string, double> pair in dF1)
                {
                    string chkitem = pair.Key;

                    Dictionary<string, int> dOpdata = new Dictionary<string, int>();

                    int currsegno = 0;
                    int scnt = 0;

                    foreach (KeyValuePair<string, int> pairS in dSeg)
                    {
                        string aa = pairS.Key.Substring(0, 5);
                        if (aa == chkitem) //skip first code
                        {
                            currsegno = pairS.Value;
                            scnt++;
                            continue;  //skip
                        }
                        if (currsegno == pairS.Value)
                            dOpdata.Add(pairS.Key, currsegno);
                    }
                    string mPrefix = chkitem;

                    int level = 1;
                    {
                        Dictionary<string, double> dFNew = new Dictionary<string, double>();  //空dictionary
                        createPRAPrefix(dOpdata, mPrefix, dFNew, level, scnt);
                    }
                }
            }


            catch (Exception e)
            {
                Console.WriteLine(" Error about PRAMain Algorithm: " + e.ToString());
            }
        }
        //==============================================
        // Return all the information
        //==============================================
        public int getCandCount()
        {
            return candcnt ;
        }
        public Dictionary<string, int> getDictPattern()
        {
            return dPattern;
        }
        private void createPRAPrefix(Dictionary<string, int> dOpdata, string mPrefix, Dictionary<string, double> dFchk, int level, int inpscnt)
        {
            
            if ((level > 1) && (inpscnt >= min_sup))
            {
                string pattern = "(,)";
                string input = mPrefix;
                Regex regex = new Regex(pattern);         // Split
                string[] substrings = regex.Split(input, input.Length);

                int itemcnt = 0;
                for (int k = 0; k < substrings.Length; k++)
                {
                    if (substrings[k] != ",")
                    {
                        itemcnt++;
                    }
                }
                if (inpscnt >= min_sup)
                {
                    dPattern.Add(mPrefix, inpscnt);
                }
            }
            foreach (KeyValuePair<string, int> pairOp in dOpdata)
            {
                string element = pairOp.Key.Substring(0, 5);
                if (dFchk.ContainsKey(element))
                {
                    dFchk[element] = dFchk[element] + 1;
                }
                else
                {
                    if (level == 1)
                    {
                        dFchk.Add(element, 1);
                    }
                }
            }

            level++;

            candcnt = candcnt + dFchk.Count;

            Dictionary<string, double> dCount = new Dictionary<string, double>();

            foreach (KeyValuePair<string, double> pairChk in dFchk)
            {
                if (pairChk.Value >= min_sup)
                {
                    dCount.Add(pairChk.Key, 0);  //frequent pattern
                }
            }
            string[] newpostfix = new string[segno];

            foreach (KeyValuePair<string, double> pair in dFchk)
            {
                if (pair.Value >= min_sup)
                {
                    string chkitem = pair.Key;
                    string currprefix = mPrefix + "," + chkitem;
                    int currsegno = 0;
                    Dictionary<string, int> dnewOpdata = new Dictionary<string, int>();
                    int scnt = 0;  //projection segment count
                    foreach (KeyValuePair<string, int> pairOp in dOpdata)
                    {
                        // Get value of  with indexer.
                        string aa = pairOp.Key.Substring(0, 5);

                        if (aa == chkitem) //skip first code
                        {
                            currsegno = pairOp.Value;
                            scnt++;
                            continue;  //skip 
                        }
                        if ((currsegno == pairOp.Value) && (dFchk[aa] >= min_sup))
                            dnewOpdata.Add(pairOp.Key, currsegno);
                    }
                    if (scnt >= min_sup)
                    {
                        if (level <= 2)
                        {
                            createPRAPrefix(dnewOpdata, currprefix, dCount, level, scnt);
                        }
                    }
                }
            }
        }
        

    }
}
